<?PHP
class AppModel extends Model {
	
	var $IdLangue = 4;
	
	function __construct($id = false, $table = null, $ds = null) {	
		if ($this->primaryKey === null) {
			$this->primaryKey = 'Id'.$this->name;
		}
		parent::__construct($id, $table, $ds);
	}
	
	/**
	 * @see function getAutocomplete() for default values
	 *
	 * @var array
	 */
	var $ac_params = array();
	
	function formatValueResult(&$item, $key) {
			$item['value'] = @$item[$this->ac_params['value']];
			$item['result'] = @$item[$this->ac_params['result']];
	}

	function getAutocomplete($q, $limit, $conditions = array()) {
		$default_ac_params = array('alias'=>$this->alias,'search'=>'Nom', 'value'=>'Nom', 'result'=>'Nom', 'joins' => array());
		$this->ac_params = array_merge($default_ac_params, $this->ac_params);
		$alias = $this->alias;
		$search = (strpos($this->ac_params['search'], '.')>0 ? $this->ac_params['search'] : "$alias.{$this->ac_params['search']}");
		
		if ($this->name == 'Auteur') {
			$conditions["$search LIKE N"] = "$q%";
		} else {
			$conditions["$search LIKE "] = "$q%";
		}
		
		$params = array(
			'conditions' => $conditions, //array of conditions
			'recursive' => 1, //int
			'order' => array("$search"), //string or array defining order
			'limit' => $limit,
			'joins' => $this->ac_params['joins']
		);
		
		$a = $this->find('all', $params);
		$data = Set::extract("{n}.$alias", $a);

		array_walk($data, array($this, 'formatValueResult'));
		
		return $data;
	}
	
	function beforeFind() {
		//настройки для связанных таблиц те же что и у основной
    	foreach ($this->tableToModel as $model){
    		if(isset($this->{$model}) && is_object($this->{$model})){
    			$this->{$model}->setDataSource($this->useDbConfig);
    		}
    	}
    }
    
}
?>