<?php

require_once('widgets.inc.php');

/**
 * Контроллер для работы с моделью Paramopac,
 * содержащей настройки OPAC 
 * @author Alex
 */ 
class AuteursController extends WidgetsController{

	var $name = 'Auteurs';
	var $pageTitle;
	var $uses = array('Auteur', 'NoticeZ', 'Book');
	var $helpers = array('Html', 'Form', 'BookHelper');
	
	var $paginate = array(
        'limit' => 15,
        'order' => array(
            'Auteur.Nom' => 'asc',
            'Auteur.Prenom' => 'asc',
        )
    );
	/**
	 * Auteur model
	 * @var Auteur
	 */
	var $Auteur;
	
	/**
	 * Books model
	 * @var NoticeZ
	 */
	var $NoticeZ;
	
	/**
	 * Books model
	 * @var Book
	 */
	var $Book;
	
	function beforeFilter() {
		parent::beforeFilter();
		$this->Auth->allow('*');
	}

	function index($source = 'default', $remote = false) {
		$fields = array($this->Auteur->primaryKey, 'Prenom', 'Initials', 'Nom', 'VoirAussi');
		$this->paginate['fields'] = $fields;
		
		// Для отображения текущего фильтра на форме 
		// будет установлена  переменная filter для View
		//
		$default_filter = array('Auteur'=>array('Nom'=>''));
		$filter = array_merge($default_filter, $this->Filter->filterOptions);
		
		$filter_form_settings[0]['Header'] = __('Введите часть фамилии автора: ',true);
		$filter_form_settings[0]['Model']  = 'Auteur';
		$filter_form_settings[0]['Fields']['Nom'] = array('label'=>'', 'type'=>'string');
					
		$this->set('filter_form_settings', $filter_form_settings);
		//$f = $this->Filter->filter;
		
		$this->paginate['contain'] = array('GeneralAuteur'=>array('fields'=>array('Nom', 'Prenom')));
		$res = $this->paginate('Auteur', $this->Filter->filter);
		
		$ids = Set::extract('{n}.Auteur.IdAuteur', $res);
		$noticeCount = $this->Auteur->getNoticeCount($ids);
		
		$this->set('auteurs', $res);
		$this->set('idField', $this->Auteur->primaryKey);
		$this->set(compact('source','filter','noticeCount'));
		
	}
	
	function beforeRender(){
		parent::beforeRender();
		$this->pageTitle = __('Указатель авторов',true);
		$default = array('Auteur.Nom'=>'');
		$request = array_merge($default, $this->params['named']);
		if($this->data){
			$request = array_merge($request, Set::flatten($this->data));
		}
		$this->set('filterValue', str_replace('%','*',$request['Auteur.Nom']));
	}
	
	function view($id) {

		$res = $this->Auteur->read(null, $id);
		$this->set('auteur', $res);
		
		$sortBy = array(
			'title' => 'Book.Titre',
			'date' => 'Book.IdNotice',
			'default' => 'Book.IdNotice',
		);
		$sort_name = $this->passedArgs['order'];
		$sort = 'Book.IdNotice';
		if(!empty($sort_name)) $sort = (key_exists($sort_name,$sortBy)) ? $sortBy[$sort_name] : $sortBy['default'];
		unset($this->passedArgs['order']);
		// load books 
		//
		$conditions = array('NoticeZ.IdZone'=>'200', 'OR'=>array('NoticeZ.sZone'=>array('f', 'g')), 'NoticeZ.ValeurN'=>$id);
		$recursive  = 0;
		$fields     = array('NoticeZ.IdNotice');
		
		$book_ids = $this->NoticeZ->find('all', compact('conditions', 'fields', 'recursive'));
		$book_ids = Set::extract('{n}.NoticeZ.IdNotice', $book_ids);
		
		if (count($book_ids) == 0) return;
		$ids_print = $this->params['form']['ids_print'];
		if($ids_print !=''){
			$this->set('ids_print',$ids_print);
		}
		
		$this->Book->recursive = 1;
		$res = $this->Book->read(null, $id);
		$this->paginate['Book']['order'] = array($sort);
		$this->paginate['Book']['contain'] = array('NoticeZ', 'ExemplaireStat', 'Exemplaire'=>a('Statut','Annexe','Bibliotheque'),'Rating');
		$this->set('books', $this->paginate($this->Book, array('Book.IdNotice'=>$book_ids)));
		
		if($this->RequestHandler->isAjax()) { 
			$this->viewPath = 'books';
			$this->set('isAjax', true);
			$this->render('books_list_ajax'); 
		};
	}
}
?>