<?php

require_once('widgets.inc.php');

/**
 * Контроллер для работы с моделью Paramopac,
 * содержащей настройки OPAC 
 * @author Alex
 */ 
class CollectionsController extends WidgetsController{

	var $name = 'Collections';

	var $pageTitle ;
	var $uses = array('Collection', 'NoticeZ', 'Book');
	var $helpers = array('Html', 'Form', 'BookHelper');
	
	var $paginate = array(
        'limit' => 15,
        'order' => array(
            'Collection.Libelle' => 'asc',
            //'Auteur.PreNom' => 'asc',
        ),
        'recursive' => 1,        
    );
	/**
	 * Collection model
	 * @var Collection
	 */
	var $Collection;
	
	/**
	 * Books model
	 * @var NoticeZ
	 */
	var $NoticeZ;
	
	/**
	 * Books model
	 * @var Book
	 */
	var $Book;
	
	function beforeFilter() {
		parent::beforeFilter();
		$this->Auth->allow('*');
	}
	
	function beforeRender(){
		parent::beforeRender();
		$this->pageTitle= __('Справочник серий издательств',true);
		$default = array('Collection.Libelle'=>'');
		$request = array_merge($default, $this->params['named']);
		if($this->data){
			$request = array_merge($request, Set::flatten($this->data));
		}
		$this->set('filterValue', str_replace('%','*',$request['Collection.Libelle']));
	}

	function index($source = 'default', $remote = false) {
		//$fields = array('*'); //$this->Collection->primaryKey, Libelle, LibelleParallel
		//$this->paginate['fields'] = $fields;
		
		// Для отображения текущего фильтра на форме 
		// будет автоматически установлена  переменная filter для View
		//
		$default_filter = array('Collection'=>array('Libelle'=>''));
		$filter = array_merge($default_filter, $this->Filter->filterOptions);
		
		$filter_form_settings[0]['Header'] = __('Введите часть названия серии: ',true);
		$filter_form_settings[0]['Model']  = 'Collection';
		$filter_form_settings[0]['Fields']['Libelle'] = array('label'=>'', 'type'=>'string');
					
		$this->set('filter_form_settings', $filter_form_settings);
		
		$res = $this->paginate($this->Collection, $this->Filter->filter);
		
		$ids = Set::extract('{n}.Collection.IdCollection', $res);
		$noticeCount = $this->Collection->getNoticeCount($ids);
		
		$this->set('filter', $filter);
		$this->set('noticeCount', $noticeCount);
		$this->set('collections', $res);
		$this->set('idField', $this->Collection->primaryKey);
		$this->set('source', $source);
	}
	
	function afterRender(){
		parent::afterFilter();
		$this->set('filterValue', $this->data['Auteur']['Nom']);
	}
	
	function view($id) {
		$res = $this->Collection->read(null, $id);
		$this->set('collection', $res);
		
		// load books 
		//
		$conditions = array('NoticeZ.IdZone'=>'225', 'OR'=>array('NoticeZ.sZone'=>array('a')), 'NoticeZ.ValeurN'=>$id);
		$recursive  = 0;
		$fields     = array('NoticeZ.IdNotice');
		$book_ids = $this->NoticeZ->find('all', compact('conditions', 'fields', 'recursive'));
		$book_ids = Set::extract('{n}.NoticeZ.IdNotice', $book_ids);
		
		if (count($book_ids) == 0) return;
					
		$this->Book->recursive = 1;
		$this->paginate['Book'] = array('order'=>array('Book.IdNotice'));
		$this->paginate['Book']['contain'] = array('NoticeZ', 'ExemplaireStat','Exemplaire'=>a('Statut'),'Rating');
		$this->set('books', $this->paginate($this->Book, array('Book.IdNotice'=>$book_ids)));
		
		$ids_print = $this->params['form']['ids_print'];
		if($ids_print !=''){
			$this->set('ids_print',$ids_print);
		}
		
		if($this->RequestHandler->isAjax()) { 
			$this->viewPath = 'books';
			$this->set('isAjax', true);
			$this->render('books_list_ajax'); 
		};
	}
}
?>