<?php
require_once('widgets.inc.php');

class KnigobMatieresController extends WidgetsController{

	var $name = 'KnigobMatieres';
	var $helpers = array('Html', 'Form');
	var $uses = array('KnigobMatiere', 'KnigobViewBook', 'KnigobBooksStudent');
	var $paginate = array(
        'limit' => 25,
        'order' => array(
            'KnigobMatiere.Sujet' => 'asc'
        )
    );
    
    function beforeFilter() {
    	parent::beforeFilter();
    	$this->Auth->allow('index', 'view');
    }
    
   	function index($id) {
		
		$default_filter = array('KnigobMatiere'=>array('Sujet'=>''));
		$filter = array_merge($default_filter, $this->Filter->filterOptions);	
		$filter_form_settings[0]['Header'] = __('Введите часть фамилии автора: ',true);
		$filter_form_settings[0]['Model']  = 'KnigobMatiere';
		$filter_form_settings[0]['Fields']['Sujet'] = array('label'=>'', 'type'=>'string');
		$this->set('filter_form_settings', $filter_form_settings);
		$this->set('filter', $filter);
   		$this->set('title', __('Книгообеспеченность по дисциплинам', true));
		$this->KnigobMatiere->recursive = 0;
		if($this->data){
			$filterValues = Set::flatten($this->data);
		}
		foreach ($filterValues as $k=>$v){
			$filterValues[$k] = str_replace('*','%',$v);
		}
		$this->set('knigobMatieres', $this->paginate(null, $this->Filter->filter));
	}

	function view($id = null) {
		if (!$id) {
			$this->Session->setFlash(__('Неправильная книгообеспеченность по дисциплине.', true));
			$this->redirect(array('action'=>'index'));
		}
		
		$knigobMatiere = array();
		
		if ($fast = true) {
			$this->KnigobMatiere->unbindModel(
        		array('hasAndBelongsToMany' => array('book'))
    		);
    		$book = $this->KnigobViewBook->findAllByIdMatiere($id);
    		
    		$notices = Set::extract('{n}.0.IdNotice', $book);
    		
    		$students = array();
    		if (!empty($notices)) {
    			$students = $this->KnigobBooksStudent->find('all', array('conditions'=>array('IdNotice' => $notices)));
    		
    			$book = Set::extract('{n}.0', $book);
    			$students = Set::combine($students, '{n}.KnigobBooksStudent.IdNotice', '{n}.KnigobBooksStudent', '{n}.KnigobBooksStudent.odd');
    		}
		} else {
			$this->KnigobMatiere->recursive = 2;
		}
		
		$matiere = $this->KnigobMatiere->read(null, $id);
		$this->set('knigobMatiere', $matiere);
		$this->set(compact('book', 'students'));
		$this->set('title', __('Книгообеспеченность по дисциплине', true).' - '.$matiere['KnigobMatiere']['Sujet']);
	}
}
?>