<?php

require_once('widgets.inc.php');

class MatieresController extends WidgetsController {

	var $name = 'Matieres';
	var $helpers = array('Html', 'Form', 'BookHelper');
	var $uses = array('Matiere','Thesaurus','Book', 'LienMatiere');
	
	/**
	 * @var Book
	 */
	var $Book;
	/** @var Matiere */
	var $Matiere;
	
	var $paginate = array(
		'Matiere' => array(
		  'limit' => 25,
          'order' => array(
          'Matiere.SujetRech' => 'asc',
          ),
        ),
        'Book' =>  array(
        	'limit' => 25,
        	'recursive'=>1,
        	'order' => array(
          		'Book.TitreOpac' => 'asc',
          		'Book.DateCreation' => 'asc',
          	)
        )
    );

	
	function beforeFilter() {
		parent::beforeFilter();
		$this->Auth->allow('index', 'view', 'full_list', 'print_matiere');

		$idPere = Set::extract('Matiere.IdPere', $this->data);

		if (!is_null($idPere)) return;
		if (!empty($this->params['named'])) return;

		$idPere = Set::extract('Matiere.IdPere', $this->params['named']);
		
		if (is_null($idPere)) {
			if(!Set::extract('Matiere.Sujet', $this->data)) {
				$this->data = Set::insert($this->data, 'Matiere.Niveau', '0');
			}
		} else {
			$this->data = Set::insert($this->data, 'Matiere.IdPere', $idPere);
		}

		return;
	}

	function index() {
		$this->set('title', __('Тезаурус - Рубрики', true));
			
		$this->Matiere->recursive = 1;
		
		/** @var $filterUrl URL для использования в ссылках пагинации **/
		$filterUrl = $this->Filter->filterOptions;
		
		/** @var $filterValues Массив значения фильтра для отображения их на форме фильтрации **/
		$default = array('Matiere.IdThesaurus'=>'', 'Matiere.Sujet'=>'');
		$filterValues = array_merge($default, $this->params['named']);
		if($this->data){
			$filterValues = array_merge($filterValues, Set::flatten($this->data));
		}
		foreach ($filterValues as $k=>$v){
			$filterValues[$k] = str_replace('%','*',$v);
		}
			
		/** @var $filter Массив параметров фильтра для пагинации **/
		$filter = $this->Filter->filter;
		
		$this->set('thesauruses', $this->Thesaurus->find('list', array('fields' => array('Thesaurus.IdThesaurus', 'Thesaurus.Libelle'))));	
		$matieres = $this->paginate(null, $filter);
		
		//
		$retenueMatieres = array();
		$retenues = Set::filter(Set::extract('{n}.Matiere.IdRetenue', $matieres));
		foreach ($retenues as $ret_id) {
			$straight_chain = array_reverse($this->Matiere->getFullChain($ret_id));
			$libelle_chain = Set::extract('/Sujet', $straight_chain);
			$retenueSujets[$ret_id] = $libelle_chain;
		}
		
		//$matieres = $this->paginate(null, array('Matiere.IdPere <' => 0));
				
		$IdPere = Set::extract('named.{Matiere.IdPere}',$this->params);
		if(count($IdPere) > 0){
			$breadcrumb = $this->Matiere->getFullChain($IdPere);
		}
		
		$parentMatiere = null;
		
		if (count($IdPere) > 0) { 	
			$IdPere = $IdPere['Matiere.IdPere'];
			$parentMatiere = $this->Matiere->read(null, $IdPere);
		}
		
		$ids = Set::extract('{n}.Matiere.IdMatiere', $matieres);
		$subcount = $this->Matiere->get_subcount($ids);
				
		$noticeCount = $this->LienMatiere->getNoticeCount($ids);
		// echo $noticeCount;
		
		//$subcount2 = $this->Matiere->get_subcount(Set::extract('{n}.Matiere.IdMatiere', $matieres), false);
		
		$this->set(compact('matieres','subcount', 'filterUrl', 'filterValues',
						 'parentMatiere', 'noticeCount','breadcrumb', 'retenueSujets'));		
	}

	function view($id = null) {
		$defaults = array('recursive'=>0);
		$this->params['named'] = array_merge($defaults, $this->params['named']);
		
		if ($this->params['named']['recursive'] == 1) {
			$res = $this->LienMatiere->find('all', array('fields'=>array('IdMatiereChild'), 'conditions'=>array('IdMatiereParent'=>$id)));
			$id = Set::extract('/LienMatiere/IdMatiereChild', $res);
			$filterOptions['url']['recursive'] = $this->params['named']['recursive'];
		}
				
		if (!$id) {
			$this->Session->setFlash(__('Неправильная рубрика.', true));
			$this->redirect(array('action'=>'index'));
		}
		$breadcrumb = $this->Matiere->getFullChain($id);
		if ($fast = true) {
			$conditions = array('NoticeZ.IdZone'=>'R600', 'NoticeZ.ValeurN' => $id);
			$fields = array('DISTINCT idNotice');
			$books_ids = Set::extract('/NoticeZ/idNotice',
							$this->Book->NoticeZ->find('all',compact('conditions','fields')));			
			
			$this->paginate['Book']['contain'] = array('NoticeZ', 'ExemplaireStat','Exemplaire'=>a('Statut'),'Rating');
			$conditions  = array('Book.IdNotice'=>$books_ids);
			$books = $this->paginate($this->Book, $conditions);
		}
		$this->set('knigobMatiere', $this->Matiere->read(null, $id));
		$this->set(compact('books','breadcrumb'));
		$ids_print = $this->params['form']['ids_print'];
		if($ids_print!=''){
			$this->set('ids_print',$ids_print);
		}
		
		if($this->RequestHandler->isAjax()) { 
			$this->viewPath = 'books';
			$this->set('isAjax', true);
			$this->render('books_list_ajax'); 
		};
		$this->set('filterOptions',$filterOptions);
	}
	
	function full_list(){
		if(is_array($this->params['named'])){
			// отсеиваем ненужное
			foreach ($this->params['named'] as $name=>$val){
				if(in_array($name,a('page','Matiere.Sujet'))){
					unset($this->params['named'][$name]);
				}
			}
			
			$cond = $this->params['named'];
			if(!array_key_exists('Matiere.IdPere',$this->params['named'])){
				//$cond = array_merge($cond,array('Matiere.IdPere is Null'));
			}
		}
		$this->paginate['Matiere'] =
				array_merge($this->paginate['Matiere'],
				array(
					'conditions' => $cond,
					'limit' => 2000
		));
		$this->index();
		$this->render('index');
	}
	
	function print_matiere($id){
		if( $id>0 ){
			$this->layout = 'ajax';
			$conditions = array('NoticeZ.IdZone'=>'R600', 'NoticeZ.ValeurN' => $id);
			$fields = array('DISTINCT idNotice');
			$books_ids = Set::extract('/NoticeZ/idNotice',
							$this->Book->NoticeZ->find('all',compact('conditions','fields')));	
			if (Configure::read() >= 3) {
				$this->set('liber_debug', compact('books_ids'));
			}
			$res = $this->requestAction(array('controller' => 'Books', 'action' => 'print_books'), array('return', 'form' => array('default'=>$books_ids)));
			$this->set('res',$res);
		}
	}

}
?>