<?php
class ProfessionsController extends AppController {

	var $name = 'Professions';
	var $helpers = array('Html', 'Form');
	var $uses = array('Profession', 'KnigobMatiere');
	
	function beforeFilter() {
    	parent::beforeFilter();
    	$this->Auth->allow('index', 'view');
    }

	function index() {
		$this->set('title', __('Книгообеспеченность по специальностям', true));
		$this->Profession->recursive = 0;
		$this->set('professions', $this->paginate(null, $this->Profession->conditions));
	}

	function view($id = null) {
		if (!$id) {
			$this->Session->setFlash(__('Неправильная специальность.', true));
			$this->redirect(array('action'=>'index'));
		}
		$profession = $this->Profession->read(null, $id);

		foreach ($profession['matieres'] as $key => $matiere) {
			$profession['matieres'][$key]['knigob'] = $this->KnigobMatiere->getKnigob($matiere['IdMatiere'], $matiere['Term']);
		}
		
		$this->set('title', __('Книгообеспеченность по специальности', true).' - '.$profession['Profession']['Libelle']);
		$this->set('profession', $profession);
	}

}
?>