<?php

require_once('widgets.inc.php');

App::import('Sanitize');

class ReservationsController extends WidgetsController {
	var $name = 'Reservations';
	var $uses = 'Book';
	
	/**
	 * @var Book
	 */
	var $Book;
	
	function beforeFilter() {
		parent::beforeFilter();
		$this->Auth->allow('add');
	}
	
	function index($id = null) {
		if (!$id) {
			$this->Session->setFlash(__('Неправильная книга.', true));
			return ;
		}
		$this->Book->recursive = 5;
		$this->Book->contain(array('Exemplaire'=>array('Annexe')));
		$book = $this->Book->find('all', array('conditions'=>array($this->Book->primaryKey => $id)));
		$this->set('book', $book);
		return;
	}

	/**
	 * Резервация с вводом пароля в момент бронирования
	 */
	function add() {
		$this->loadModel('RemoteReservation');
		$data = array();
		if (!isset($this->params['form'])) $this->Session->flash(__('Ошибка - нет данных',true));
		$data = $this->params['form'];
			
		$opac_config = Configure::read('opac_sources');
		/* @var $opac_config NEW_OPAC_CONFIG */
		
		$source = Sanitize::paranoid($data['source']);

		$url = $opac_config->GetParam($source, 'resa_url');
		$data['FicLog'] = $opac_config->GetParam($source, 'fic');
		$data['IdSession'] = 'OPAC';
		$data['IdLangue'] = $this->IdLangue;
				
		if (empty($url) or empty($data['FicLog'])) {
			
			$sError = __('Бронирование не настроено для данного описания. Пожалуйста, обратитесь к библиотекарю.',true);
			
			$this->autoRender = false;
			$this->set('TopElement', 'div');
			$this->set('Data', $sError);
			$this->render('getHtml', 'ajax');
			return;
		}
		
		// Резервируем и получаем сообщение об ошибке, если что не так
		$res = $this->RemoteReservation->doReservation($data, $url);		
		$res_headers = $this->RemoteReservation->getResponseHeaders();
		
		if (key_exists('return', $this->params) && $this->params['return']) {
			return $res;
		} else {
			$this->autoRender = false;

			$this->set('TopElement', 'div');
			$this->set('Data', $res);

			$this->render('getHtml', 'ajax');
		}

		return;
	}
}
?>
