<?php
require_once('widgets.inc.php');

class SearchFormsController extends WidgetsController
{

	var $name = 'SearchForms';
	var $uses = array('SearchForm', 'DefChamp', 'Solr');
	/**
	 * Объект модели SearchForm
	 * @var SearchForm
	 */
	var $SearchForm;
	/**
	 * Объект модели Solr
	 * @var Solr
	 */
	var $Solr;

	/**
	 * Выводит HTML форму для поиска
	 *
	 * @param int ID поисковой формы
	 */
	function index($RechId = null)
	{
		$this->set('title', __('Поиск', true));
		
		// поиск одной строкой
		if($RechId >= 3){
			$this->render('search');
		}

		if (!is_null($RechId)) {
			// Загрузим список настроенных полей для поиска
			$this->set('FormControls', $this->SearchForm->getControls($RechId));

			// Загрузим список всевозможных полей для поиска
			$this->set('AllFormControls', $this->SearchForm->getAllControls($RechId));

			$this->set('Operations', $this->_getOperations());

			// добавление  поиска по экземплярам
			$this->set('Checkboxes',$this->SearchForm->getCheckboxes());
			$this->set('Buttons',$this->SearchForm->getButtons());

			// добавление поиска по другим признакам
			$this->set('AdditionFilds',array('Notice.Categ' => $this->SearchForm->getDocumentCategFields()));

			// добавление поиска по филиалам библиотек
			$this->set('Libraries',$this->SearchForm->getLibraries());
		}

	}

	// @todo: rewrite. BREACKS MVC!!
	//
	function _getOperations() {
		$aOperations['AND'] = __('И', true);
		$aOperations['OR'] = __('ИЛИ', true);
		$aOperations['NOT'] = __('НЕ', true);
		return $aOperations;
	}


	function getResultCount() {
		$this->data['getCount'] = true;
		$res = $this->requestAction(
			array('controller' => 'SearchForms', 'action' => 'simpleSearch', 'data' => $this->data));

		return;
	}

	function simpleSearch($Id = null) {
		$aSearchResult = $this->requestAction(
			array('controller' => 'notices', 'action' => 'search', 'data' => $this->data));

		/* @var $this->RequestHandler RequestHandler */
		$this->RequestHandler->setContent('html', 'application/xml, text/xml');
		

		$this->RequestHandler->__responseTypeSet = null;
		$this->RequestHandler->renderAs($this,'ajax');

		$this->set('TopElement', 'Notices');
		
		if(Configure::read('opac.serchresult.total_exp_string')){
			foreach ($aSearchResult as $id_lib=>$lib_res){
			  foreach ($lib_res['source']['notice'] as $i=>$notice){
				if(!$notice['total']){
					$aSearchResult[$id_lib]['source']['notice'][$i]['total'] = __('НЕТ',true);
					$aSearchResult[$id_lib]['source']['notice'][$i]['availible'] = __('НЕТ',true);
				}
			  }
			}
		}
		
		$this->set('Data', $aSearchResult);
		$this->render('getXml', 'ajax');


		return;
	}
	
	function search($request='', $page=0, $sort='', $ids_print=''){
		$isAjax = false;
		$request = coalesce(Sanitize::stripAll($request),$this->data['query']);
		$page = (int)$this->params['form']['page'];
		$sort = coalesce($this->params['form']['order'], '');
		$ids_print = coalesce($this->params['form']['ids_print'], '');
		if($request != ''){	
			$isAjax = true;
			$this->Solr->setPage($page);
			$this->Solr->setSort($sort);
			$data = $this->Solr->simpleSearch($request);
			$ids = Set::extract('response.docs.{n}.id',$data);
			$this->loadModel('Book');
			if(count($ids) > 0){
				$this->Book->unbindModel(
					array('hasAndBelongsToMany' => array('Cible','Source'))
				);
				$this->Book->recursive = 2;
				$books = $this->Book->find('all',array('conditions'=>array('Book.IdNotice' => $ids)));
				//$books = $this->Book->findAllByIdNotice($ids);
			}
			$this->set('books', $books);
			$this->set('sortable', $this->Solr->fields['sortable']);
			$this->set('data', $data);
			$this->set('sort', $sort);
			
			$this->set('page', $page);
			$this->set('limit', $this->Solr->limit);
		}
		
		$this->set('ids_print', $ids_print);
		$this->set('title', __('Поиск одной строкой', true));
		$this->set('isAjax', $isAjax);
		
		if($isAjax){
			$this->render('search', 'ajax');
		}
	}
	
	function reindex($type = 'delta'){
		$delta = ($type != 'full');
		$this->Solr->reindex($delta);
		$this->redirect(array('action'=>'search'));
	}

	function beforeFilter(){
		parent::beforeFilter();
		$this->Auth->allow('*');
		$this->Security->validatePost = false;
	}

	function afterFilter() {
		if ($this->RequestHandler->isAjax()) {
			header('Content-type:'.$this->RequestHandler->__responseTypeSet,true);
		}
	}

	/**
	 * преобразует массив о библиотеках и филиалах
	 * и передаёт на вывод в формате JSON
	 */
	function getLibrariesFilials(){
		$data = $this->SearchForm->getLibraries();

		foreach ($data as $library){
			// библиотеки
			$nodes[] = array('text'=>"{$library['name']}", 'id'=>"{$library['confname']}", 'cls'=>'folder');
			//филиалы
			foreach ($library['filials'] as $idFilial=>$filial){
				$nodes[] = array('text'=>"$filial", 'id'=>"{$library['confname']}_"."$idFilial", 'leaf'=>true, 'cls'=>'file');
			}
		}

		$this->autoRender = false;
		$this->set('data', $nodes);
		$this->render('getJson', 'ajax');
	}

	function autocomplete(){
		extract($this->params['named']);
		extract($this->params['url']);
		
		$model = $this->DefChamp->getFieldModel($Field);
		
		if (is_null($model)) return;
		
		App::import('Model', $model);
		
		$ac_model = new $model;
		$ac_method = 'getAutocomplete';
		$q = str_replace('*','%',$q);
		
		if (method_exists($ac_model, $ac_method)) {
			$data = $ac_model->$ac_method($q, $limit);
		}
		
		$this->set('data', $data);
		$this->render('getJson', 'ajax');
	}
}

?>