<?php
class SpecialitiesController extends AppController {

	var $name = 'Specialities';
	var $helpers = array('Html', 'Form');
	var $uses = array('Speciality', 'KnigobMatiere');
	
	function beforeFilter() {
    	parent::beforeFilter();
    	$this->Auth->allow('index', 'view');
    }

	function index() {
		$this->set('title', __('Книгообеспеченность по специализациям', true));
		$this->Speciality->recursive = 0;
		$this->set('professions', $this->paginate(null, $this->Speciality->conditions));
	}

	function view($id = null) {
		if (!$id) {
			$this->Session->setFlash(__('Неправильная специализация.', true));
			$this->redirect(array('action'=>'index'));
		}
		$profession = $this->Speciality->read(null, $id);

		foreach ($profession['matieres'] as $key => $matiere) {
			$profession['matieres'][$key]['knigob'] = $this->KnigobMatiere->getKnigob($matiere['IdMatiere'], $matiere['Term']);
		}
		
		$this->set('title', __('Книгообеспеченность по специализациям', true).' - '.$profession['Speciality']['Libelle']);
		$this->set('profession', $profession);
	}

}
?>