<?php 
require_once('widgets.inc.php');

class TagsController extends WidgetsController{
	
	var $name = 'Tags';
	var $uses = array('Tag', 'NoticesTags','Book');
	var $helpers = array('Html', 'Form', 'BookHelper');
	
	/**
	 * @var Tag
	 */
	var $Tag;
	
	/**
	 * @var NoticesTags
	 */
	var $NoticesTags;
	
	function beforeFilter(){
		if (!in_array(LIBER_PLUGIN_WEB20, Configure::read(LIBER_PLUGINS))){
			$this->redirect('/') ;
		}
		parent::beforeFilter();
		$this->user_id = $this->Auth->user('IdUsager');
		$this->Auth->allow('complite','view', 'show_list');
		header('Cache-Control: no-cache');
	}
	
	function add(){
		//
		if (!empty($this->data)) {
			$this->data['Tag']['user_id'] = $this->data['NoticesTags']['user_id'] = $this->user_id;
			$this->data['Tag']['created'] = $this->data['NoticesTags']['created'] = null;

			// не сравнение		
			if(! $tag_id = $this->getTagIdByName($this->data['Tag']['tag'])){
				$this->Tag->create();
				$this->Tag->save($this->data);
				$tag_id = $this->Tag->id;
			}
			
			$this->data['NoticesTags']['tag_id'] = $tag_id	;
			$notice_id = $this->data['NoticesTags']['notice_id'] = $this->data['Tag']['notice_id'];
			// if tag exist
			$dublicate = $this->NoticesTags->find('first',array('conditions'=>array('notice_id'=>$notice_id,'tag_id'=>$tag_id)));
			if($dublicate !=false && count($dublicate)>0){
				$this->Session->setFlash(__('Тег уже задан', true));
			}else{
				// if tag not exist
				$this->NoticesTags->create();
				if ($this->NoticesTags->save($this->data)) {
					$this->Session->setFlash(__('тег сохранен', true));
				} else {
					$this->Session->setFlash(__('тег не сохранен. Пожалуйста повторите попытку.', true));
				}
			}
		}
		$this->redirect(array('controller'=>'notices', 'action'=>'index', $this->data['Tag']['notice_id']));

	}
	
	function complite($text){
		$this->layout = 'ajax';
		$this->Tag->ac_params['search'] = 'tag';
		if($text=='' || $text == 'undefined') $text = '';
		$this->set('res',Set::combine($this->Tag->getAutocomplete($text,1000),'{n}.id','{n}.tag'));
		$this->render('/tags/complite');
	}
	
	function getTagsByIdNotice($idNotice){
		$res = $this->NoticesTags->find('all',array('conditions'=>array('notice_id'=>$idNotice), 'fields'=>array('tag_id')));
		if($res != false && count($res)>0){
			$tag_ids = Set::extract('{n}.NoticesTags.tag_id',$res);
			$res = $this->Tag->find('all',array('conditions'=>array('id'=>$tag_ids),'fields'=>array('id','tag')));
			return Set::combine($res,'{n}.Tag.id','{n}.Tag.tag');
		}
		return  array();
	}
	
	function view($idNotice = null){
		$tags = $this->getTagsByIdNotice($idNotice);
		if (isset($this->params['requested'])) {
			return $tags;
		}else{
			$this->set(compact('tags'));
		}
	}
	
	function getTagIdByName($name){
		$tag = $this->Tag->find('first',array('conditions'=>array('tag'=>$name)));
		if($tag == false) return false;
		return $tag['Tag']['id'];
	}
	
	function show_list($id = null){
		$query = str_replace('*','%',$this->params['data']['Tag']['tag']);
		if(is_numeric($id)){
			$tags = $this->Tag->find('all',array('conditions'=>array('Tag.id'=>$id)));
		}elseif(is_string($query) && $query != ''){
			$tags = $this->Tag->find('all',array('conditions'=>array('Tag.tag like'=>$query)));
		}else{
			$tags = $this->Tag->find('all');
		}
		$ids = Set::extract('{n}.NoticesTags.{n}.notice_id',$tags);
		foreach ($ids as $id){
			foreach ($id as $val){
				$ids_notice[] = $val;
			}
		}
		$books = $this->paginate($this->Book,array('Book.IdNotice'=>$ids_notice));
		$this->set('books',$books);
		//$this->set('tag',$tags[0]['Tag']);
	}
}
?>