<?php

require_once('widgets.inc.php');

class UdkWithoutTablesController extends WidgetsController{
	
	var $name = 'UdkWithoutTables';
	
	var $pageTitle ;
	var $uses = array('UdkWithoutTable', 'NoticeZ', 'Book');
	var $helpers = array('Html', 'Form', 'BookHelper');
	
	var $paginate = array(
	        'limit' => 15,
			'order' => array('UdkWithoutTable.id' => 'asc'),
	        'recursive' => 1,
	);
	
	/**
	 * Books model
	 * @var NoticeZ
	 */
	var $UdkWithoutTable;
	
	/**
	* Books model
	* @var NoticeZ
	*/
	var $NoticeZ;
	
	/**
	 * Books model
	 * @var Book
	 */
	var $Book;
	
	function beforeFilter() {
		parent::beforeFilter();
		$this->Auth->allow('*');
	}
	
	function beforeRender(){
		parent::beforeRender();
		$this->pageTitle= __('Справочник индексов УДК',true);
		$request = array_merge($default, $this->params['named']);
		if($this->data){
			$request = array_merge($request, Set::flatten($this->data));
		}
		$this->set('filterValue', str_replace('%','*',$request['UdkWithoutTable.id']));
	}
	
	function index($source = 'default', $remote = false){
		
		$default_filter = array('UdkWithoutTable'=>array('id'=>''));
		$filter = array_merge($default_filter, $this->Filter->filterOptions);
		
		$filter_form_settings[0]['Header'] = __('Введите часть названия УДК: ',true);
		$filter_form_settings[0]['Model']  = 'UdkWithoutTable';
		$filter_form_settings[0]['Fields']['id'] = array('label'=>'', 'type'=>'string');
			
		$this->set('filter_form_settings', $filter_form_settings);
		
		$udks = $this->paginate($this->UdkWithoutTable, $this->Filter->filter);
		
		$this->set('filter', $filter);
		$this->set('udks',$udks);
		$this->set('idField', $this->UdkWithoutTable->primaryKey);
		$this->set('source', $source);
	}
	
	function afterRender(){
		parent::afterFilter();
		$this->set('filterValue', $this->data['UdkWithoutTable']['id']);
	}
	
	function view($id)
	{
		$id = str_replace('slash', '/', $id);
		
		$res = $this->UdkWithoutTable->read(null, $id);
		$this->set('udk', $res);
		
		// load books
		//
		$conditions = array('NoticeZ.IdZone'=>'675', 'NoticeZ.sZone'=> 'a', 'NoticeZ.Valeur' => $id);
		$recursive  = 0;
		$fields     = array('NoticeZ.IdNotice');
		$book_ids = $this->NoticeZ->find('all', compact('conditions', 'fields', 'recursive'));
		$book_ids = Set::extract('{n}.NoticeZ.IdNotice', $book_ids);

		if (count($book_ids) == 0) return;
		
		$this->Book->recursive = 1;
		$this->paginate['Book'] = array('order'=>array('Book.IdNotice'));
		$this->paginate['Book']['contain'] = array('NoticeZ', 'ExemplaireStat','Exemplaire'=>a('Statut'),'Rating');
		$this->set('books', $this->paginate($this->Book, array('Book.IdNotice'=>$book_ids)));
		
		$ids_print = $this->params['form']['ids_print'];
		if($ids_print !=''){
			$this->set('ids_print',$ids_print);
		}
		
		if($this->RequestHandler->isAjax()) { 
			$this->viewPath = 'books';
			$this->set('isAjax', true);
			$this->render('books_list_ajax'); 
		};
	}
}