<?php
class UsersController extends AppController {

	var $name = 'Users';
	var $helpers = array('Html', 'Form');
	var $components = array('Auth');
	var $uses = array('User','Parametre');
	
	/**
	 * @var Parametre
	 */
	var $Parametre;
	
	function beforeFilter() {
		$CodbarU = $this->data['User']['CodbarU'];
		if(empty($CodbarU)) {
			parent::beforeFilter();
			return;
		}
		
		// автодополнение штрихкода читателя в соответствии с настройками 
		$params = $this->Parametre->findAll(array('CodeParametre'=>'CODE_BARRE_USAGER'));
		list($len) = Set::extract('/DetailParametre[CodeDetail=LONGNUM]/Valeur',$params);
		list($pref) = Set::extract('/DetailParametre[CodeDetail=PREFIXE]/Valeur',$params);
		list($sufix) = Set::extract('/DetailParametre[CodeDetail=SUFFIXE]/Valeur',$params);
		list($repeat) = Set::extract('/DetailParametre[CodeDetail=REMPLISSAGE]/Valeur',$params);
		list($rule) = Set::extract('/DetailParametre[CodeDetail=REGLE_VALIDATION]/Valeur',$params);
		
		// дополнение значимо части
		if((strlen($CodbarU)<$len) && ($repeat != '') && ($len > 0)){
			$CodbarU = str_pad($CodbarU,$len,$repeat,STR_PAD_LEFT);
		}
		
		switch ($rule){
			case "RG_US_00000":
				$ucb_len = $len+strlen($pref)+strlen($sufix);
				if(strlen($CodbarU) < $ucb_len){
					$this->data['User']['CodbarU'] = $CodbarU = $pref.$CodbarU.$sufix;
				}
				break;
			case "RG_US_TURG": 
			default:
				$this->data['User']['CodbarU'] = $CodbarU;
				break;
		}
		
		/* @var $opac_config BASE_SOURCE_CONFIG */
		$opac_config = Configure::read('opac_sources');
		$CutomizationCode = $opac_config->GetParam($source = 'default', 'CutomizationCode');
		if (mb_strtolower($CutomizationCode) == 'turg') {
			// если шк читателя не 3 и не временный (5)
			if (! in_array(substr($CodbarU,0,1),array('3','5'))){
				$this->data['User']['CodbarU'] = '0'.substr($CodbarU, 1); 
			}
		}
		parent::beforeFilter();
    }

	function index() {
		$this->redirect(array('action'=>'login'));
	}
	
	function login() {
	}

	function logout() {
        $this->redirect($this->Auth->logout());
    }
	
}
?>