<?php

class Auteur extends AppModel {

	var $name 		= 'Auteur';
	var $useTable 	= 'Auteur';
	var $actsAs = array('Containable');
	
	var $belongsTo = array(
	  'GeneralAuteur' => array(
	  'className' => 'Auteur',
	  'foreignKey'    => 'Voir'
	)
	);
	/*var $belongsTo = array(
	'Libelle' => array(
	'className' => 'Libelle',
	'foreignKey'    => 'IdLibelle'
	)
	);*/
	var $ac_params = array(
	  'alias' =>'_AUTEUR_FULLNAME',
	  'search'=>'_AUTEUR_FULLNAME.FullName', 
	  'value'=>'_AUTEUR_FULLNAME.FullName', 
	  'result'=>'_AUTEUR_FULLNAME.FullName', 
	  'joins'=>array(array('table'=>'_AUTEUR_FULLNAME', 'type'=>'INNER', 'conditions'=>'_AUTEUR_FULLNAME.IdAuteur = Auteur.IdAuteur')));
	
	function formatValueResult(&$item, $key) {
			$item['value'] = implode(' ', Set::filter(array(@$item['Nom'], @$item['Prenom'])));
			$item['result'] = implode(' ', Set::filter(array(@$item['Nom'], @$item['Prenom'])));
	}
	
	/**
	 * Функция подсчитывает количество описаний у автора
	 *
	 * @param mixed   $id - идентификатор автора (int или array)
	 * @return array
	 */
	function getNoticeCount($id=null) {
		if(is_null($id)) return a();
		$options = a();
		
		$options['joins'] = array(
			array(
				'table' => 'NOTICE_Z',
				'alias' => 'AutersNotice',
				'type'  => 'inner',
				'conditions' => array('AutersNotice.IdZone'=> '200', 'AutersNotice.sZone' => a('f','g'),'AutersNotice.Valeurn = Auteur.IdAuteur'),
		));
		$options['conditions'] = array('Auteur.IdAuteur' => $id);
		$options['fields'] = array('Auteur.IdAuteur',"COUNT(DISTINCT AutersNotice.IdNotice) AS books_count");
		$options['group']  = array('Auteur.IdAuteur');
		
		$res = $this->find('all', $options);
		return Set::combine($res,'{n}.Auteur.IdAuteur','{n}.0.books_count');
	}

}

?>