<?php
class Editeur extends AppModel {

	var $name = 'Editeur';
	var $useTable = 'EDITEUR';
	var $primaryKey = 'IdEditeur';

	//The Associations below have been created with all possible keys, those that are not needed can be removed
	var $hasAndBelongsToMany = array(
		'Ville' => array(
			'className' => 'Ville',
			'joinTable' => 'editeur_ville',
			'foreignKey' => 'IdEditeur',
			'associationForeignKey' => 'IdVille',
			'unique' => true,
			'conditions' => '',
			'fields' => '',
			'order' => '',
			'limit' => '',
			'offset' => '',
			'finderQuery' => '',
			'deleteQuery' => '',
			'insertQuery' => ''
		),
		
		/*
		'FOURNISSEUR' => array(
			'className' => 'FOURNISSEUR',
			'joinTable' => 'FOURNISSEUR_EDITEUR',
			'foreignKey' => 'editeur_id',
			'associationForeignKey' => 'f_o_u_r_n_i_s_s_e_u_r_id',
			'unique' => true,
			'conditions' => '',
			'fields' => '',
			'order' => '',
			'limit' => '',
			'offset' => '',
			'finderQuery' => '',
			'deleteQuery' => '',
			'insertQuery' => ''
		)*/
	);
	
	var $hasMany = array(
		'Collection' => array(
			//'className' => 'KnigobProfessionsMatieres',
			'foreignKey' => 'IdEditeur',
		)
	);
	
	var $ac_params = array('search'=>'Nom', 'value'=>'Nom', 'result'=>'Nom');
	
	/**
	 * Функция подсчитывает количество описаний у издательства
	 *
	 * @param mixed   $id - идентификатор издательства (int или array)
	 * @return array
	 */
	function getNoticeCount($id=null) {
		if(is_null($id)) return a();
		$options = a();
		
		$options['joins'] = array(
			array(
				'table' => 'NOTICE_Z',
				'alias' => 'EditorNotice',
				'type'  => 'inner',
				'conditions' => array(
					'EditorNotice.IdZone'=> '210', 
					'EditorNotice.sZone' => 'c',
					'EditorNotice.Valeurn = Editeur.IdEditeur'),
		));
		$options['conditions'] = array('Editeur.IdEditeur' => $id);
		$options['fields'] = array('Editeur.IdEditeur',"COUNT(DISTINCT EditorNotice.IdNotice) AS books_count");
		$options['group']  = array('Editeur.IdEditeur');
		
		$res = $this->find('all', $options);
		return Set::combine($res,'{n}.Editeur.IdEditeur','{n}.0.books_count');
	}
}
?>