<?php
class RemoteReservation extends AppModel
{
	var $name = 'RemoteReservation';
	var $actsAs = array('webservice' => array(
	'defaultUrl' => 'http://localhost/SoftUnicode/Modules/Notices/CtrlResaXML.php')
	);
	var $useTable = false;

	function getResponseHeaders() {
		return $this->Behaviors->webservice->response['headers'];
	}

	/**
	 * Функция запрашивает резервацию у удаленной АИБС...
	 *
	 * @param array $data - массив с пересылаемыми удаленному скрипту параметрами
	 * @example 
	 * Для всех АИБС:
	 *  $data['IdAnnexe'] = 9      // Филиал
	 *  $data['IdNotice'] = 12456  // Id описания
	 *  $data['login']
	 *  $data['password']
	 * Для АИБС Absotheque & Absotheque Unicode дополнительно нужно:
	 *  $data['FicLog'] = $opac_config->GetParam($source, 'fic');
	 *  $data['IdSession'] = 'OPAC';
	 * 	$data['IdLangue'] = $this->IdLangue;
	 *  
	 * 
	 * @param string $url - адрес удаленного скрипта бронирования
	 * @return unknown
	 */
	function doReservation($data = array(), $url = null) {
		$strMsg = 'Ошибка бронирования!';
		$res = $this->request('get', array('data' => $data, 'url' => $url));

		if(empty($res)) return $strMsg;

		uses('Xml');

		$Xml = new Xml($res);
		$a = $Xml->children[0];
		$a = $a->child('Resa');
		$isOk = $a->attributes['CTRLOK'];
		//$noMsg  = $a->attributes['NOMSG'];
		$strMsg = $a->attributes['TXTMSG'];

		if ($isOk == 1) {
			return 'Экземпляр забронирован!';
		} else {
			return 'Ошибка бронирования!'.' '.$strMsg;
		}
	}
}
?>
