<?php
class MainController extends AdminAppController {
	
	var $name = "Main";
	var $uses = array('Admin.Admins','Book','Bookshelf', 'BookshelvesBooks',
					  'Comment', 'Tag', 'NoticesTags'
	);
	var $helpers = array('Html', 'Form', 'BookHelper', 'Javascript','Ajax');
	/**
	 * @var Bookshelf
	 */
	var $Bookshelf;
	/**
	 * @var Comment
	 */
	var $Comment;
	/**
	 * @var Book
	 */
	var $Book;
	/**
	 * @var Auth
	 */
	var $Auth;
	
	function beforeFilter(){
		if (!in_array(LIBER_PLUGIN_WEB20, Configure::read(LIBER_PLUGINS))){
			$this->redirect('/');
		}
		parent::beforeFilter();
		header('Cache-Control: no-cache');
		header('Last-Modified: '.date('d M Y H:i:s').' GMT');
	}
	
	function index() {
		$this->redirect(array('action'=>'login'));
	}
	
	function login() {
	}

	function logout() {
        $this->redirect($this->Auth->logout());
    }
    
    function show_main(){
    	$this->pageTitle = __('Администрирование',true);
    	$this->paginate['Admins']['order'] = array('Nom');
    	$res = $this->paginate($this->Admins);
    }
    
    function show_shelf($id=0){
    	$this->pageTitle = __('Администрирование: Полки',true);
    	$condition = array(
    		'Bookshelf.is_public >'=> 0,
    	);
    	if(is_array($id) || $id>0){
    		$condition['Bookshelf.id'] = $id;
    	}
    	
    	$this->paginate['Bookshelf'] = array(
    		'order' => array('Bookshelf.modified desc'),
    		'limit' => 10,
    	);
    	
    	$data = $this->paginate($this->Bookshelf,$condition);
    	$this->set('bookshelves',$data);
    }
    
    function hide_shelf($id){
    	$this->data['Bookshelf']['is_public'] = 0;
    	$this->data['Bookshelf']['id'] = $id;
		if ($this->Bookshelf->save($this->data)) {
			$this->Session->setFlash(__('Книжная полка изменена', true));
		} else {
			$this->Session->setFlash(__('Книжная полка НЕ изменена', true));
		}
		$this->redirect(array('action'=>'show_shelf'));
    }
    
    function show_comments(){
    	$this->pageTitle = __('Администрирование: Комментарии',true);
    	$this->paginate['Comment'] = array(
    		'order' => array('Comment.created desc'),
    		'limit' => 10,
    	);
    	$data = $this->paginate($this->Comment);
    	$this->set('comments',$data);
    }
	
    function delete_comment($id = null){
    	if(!is_numeric($id)){
    		$this->Session->setFlash(__('Не указан комментарий для удаления',true));
    	}else{
    		if($this->Comment->delete($id,false)){
				$this->Session->setFlash(__('Комментарий успешно удален',true));
    		}else{
				$this->Session->setFlash(__('Комментарий НЕ был удален',true));
    		}
    	}
   		$this->redirect(array('action'=>'show_comments'));
    }
		
    function show_tags(){
    	$this->pageTitle = __('Администрирование: Теги',true);
    	$this->paginate['NoticesTags'] = array(
    		'order' => array('NoticesTags.created desc'),
    		'limit' => 10
    	);
    	$this->NoticesTags->recursive = 1;
    	$data = $this->paginate($this->NoticesTags);
    	$this->set('tags',$data);
    }
    
    function delete_tag($id = null){
    	$notice_tags = $this->NoticesTags->find('all',array('conditions'=>array('tag_id'=>$id)));
    	$ids = Set::extract('{n}.NoticesTags.id',$notice_tags);
    	
    	if(count($ids)>0 && is_array($ids)){
    		$this->delete_notice_tag($ids, false);
    	}

    	if($this->Tag->deleteAll(array('Tag.id'=>$id))){
    		$this->Session->setFlash(__('Тег успешно удален',true));
    	}else{
    		$this->Session->setFlash(__('Тег не был удален',true));
    	}

    	$this->redirect(array('action'=>'show_tags'));
    }
    
    function delete_notice_tag($id = null, $redirect = true){
    	$result = false;
    	if(is_numeric($id)){
    		if($result = $this->NoticesTags->delete($id,false)){
				$this->Session->setFlash(__('Тег успешно удален у описания',true));
    		}else{
				$this->Session->setFlash(__('Тег НЕ был удален  у описания',true));
    		}
    		
    	}elseif(is_array($id)){
    		if($result = $this->NoticesTags->deleteAll(array('NoticesTags.id'=>$id),false)){
    			$this->Session->setFlash(__('Теги успешно удалены',true));
    		}else{
				$this->Session->setFlash(__('Теги НЕ были удалены',true));
    		}
    		
    	}else{
    		$this->Session->setFlash(__('Не указан тег для удаления',true));
    	}
    	
    	if(!$redirect) return $result;
   		$this->redirect(array('action'=>'show_tags'));
    }
}
?>