<?php
/**
 *  Данный файл формирует таблицу по двум передаваемым параметрам
 *  $headers - массив заголовков таблицы например:
 *  $headers = array(
 *		'auteurs' => __('Автор',true),
 *		'titles' => __('Заглавие',true),
 *  );
 *  где ключи - названия массивов, передаваемых вторым параметром $data
 *  $data - массив содержащий массивы значений по столбцам таблицы, например:
 *  $data = array(
 *		'books_id' => array(21,42), // массив IdNotice
 * 		// массив авторов в формате idNotice => array(IdAuteur => 'Автор') 
 *		'auteurs' => array(21 => (array(123 => 'Пушкин')), 
 * 						   42 => (array(1253 => 'Иванов'))),
 *		'titles' => array(21 => (array(21 => 'Лукоморье')),
 * 						  42 => (array(42 => 'Мемуары'))),
 *  ); 	
 *  
 * Над значениями из $data происходит обработка согласно их имени ('auteurs','titles')
 * перед печатью.
 */

$book_link = array('controller'=>'notices', 'action'=>'index', 'Source'=>'default');
$book_remove = array('controller'=>'Bookshelves', 'action'=>'remove', 'Source'=>'default');
$book_reserve = array('controller'=>'books', 'action'=>'reserve', 'Source'=>'default');


$books_id = $data['books_id'];
$headers = $options['headers'];

// для каждой книги по порядку полей в заголовке
// формируется чтрока (row) которые объединяются в таблицу (rows)
foreach ($books_id as $book_id=>$url){
	
	$url = explode(';',$url);
	foreach ($url as $v){
		list($key,$val) = explode(':',$v);
		$link[$key] = $val;
	}
	// выделяем id книжной полки если есть
	if(!empty($link['bookshelf'])){
		$bs_id = $link['bookshelf'];
		unset($link['bookshelf']);
	}
	
	foreach ($headers as $column=>$header){
		// извлекаем в $col массив из $data[$column]
		$col = $data[$column];
		switch ($column){
			case'titles':
				$cell = coalesce($html->link(implode(', ',$col[$book_id]),
					am($book_link,$link),array('target'=>'_blank')), '&nbsp;');
				break;
			case'years':
				$cell = coalesce(implode(', ',$col[$book_id]),__('б. г.',true));
				break;
			case'date_1':
			case'date_2':
				$cell = coalesce(strftime("%d-%m-%Y", strtotime($col[$book_id][$book_id])),'&nbsp;');
				break;
			case'ratings':
				$rating = $col[$book_id]['Rating'];
				$cell = $this->element('stars',array('rating' => $rating['rating'],
							'numVotes' => $rating['numVotes'], 'notice_id'=> $book_id));
				break;
			case 'remove':
				$cell = ($col) ? $html->link(__('Удалить',true),am($book_remove,$link,a($bs_id))) : '&nbsp;' ;
				break;
			case 'reserve':
				$cell = ($col[$book_id]) ? $html->link(__('Заказать',true),am($book_reserve,$link)) : '&nbsp;' ;
				if(Configure::read('opac.reservation.hide') === 1){
					$cell = '&nbsp;';
				}
				break;
			case 'doc_type':
				$cell = coalesce($bookHelper->type[$col[$book_id]]['name'], __('Книга',true));
				break;
			case'auteurs':
			case'codbares':
			case'isbn':
			default:
				$cell = coalesce(implode(', ',$col[$book_id]),'&nbsp;');
				break;
		}
		
		$row[] = (is_array($options['columns'][$column])) ? array($cell,$options['columns'][$column]) : $cell;
	}
	
	$rows[] = $row;
	$row = array();
}

$table_param = 0;
foreach ($options['table'] as $param=>$val){
	$table_param .= $param.' = "'.$val.'" ';
}

echo '<table '.$table_param.'>';
echo $html->tableHeaders($headers);
echo $html->tableCells( $rows ,$options['oddRow'],$options['evenRow']);
echo '</table>';

?>