/****** Object:  View [dbo].[view_R600a]    Script Date: 04/29/2009 21:43:10 ******/
IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[view_R600a]'))
DROP VIEW [dbo].[view_R600a]
--==============================================
GO
/****** Object:  UserDefinedFunction [dbo].[GetSubMatiers]    Script Date: 04/29/2009 21:07:09 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[GetSubMatiers]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[GetSubMatiers]

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE FUNCTION [dbo].[GetSubMatiers] (	@IdMatiere int )
RETURNS @TblMatiere TABLE 
(
	IdMatiere int, 
	Flag int default 0
)
WITH SCHEMABINDING 
AS
BEGIN
	--declare @TblMatier table (IdMatier int, Flag int default 0)
	insert @TblMatiere(IdMatiere)
	values (@IdMatiere)

	while exists(select 1 from @TblMatiere where Flag=0)
	begin
		update @TblMatiere set Flag=1 where Flag=0
		
		insert @TblMatiere(IdMatiere)
		select IdMatiere from  dbo.MATIERE where IdPere in (select IdMatiere from @TblMatiere where Flag=1)
		
		update @TblMatiere set Flag=2 where Flag=1
	end
	
	RETURN
END
GO

SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO

--==========================================================
GO
/****** Object:  UserDefinedFunction [dbo].[GetSubMatiersForIdString]    Script Date: 04/29/2009 21:09:19 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[GetSubMatiersForIdString]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[GetSubMatiersForIdString]

GO
/****** Object:  UserDefinedFunction [dbo].[GetSubMatiersForIdString]    Script Date: 04/29/2009 21:09:44 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE FUNCTION [dbo].[GetSubMatiersForIdString] (	@IdMatiersStr varchar(max) )
RETURNS @TblMatiere TABLE 
(
	IdMatiere int, 
	Flag int default 0
)
AS
BEGIN

    DECLARE @start INT, @end INT
    SELECT @start = 1, @end = CHARINDEX(',', @IdMatiersStr)

    WHILE @start < LEN(@IdMatiersStr) + 1 BEGIN
        IF @end = 0 
            SET @end = LEN(@IdMatiersStr) + 1

		insert @TblMatiere(IdMatiere)
		VALUES( CAST(SUBSTRING(@IdMatiersStr, @start, @end - @start) AS INT))

        SET @start = @end + 1
        SET @end = CHARINDEX(',', @IdMatiersStr, @start)
    END


	while exists(select * from @TblMatiere where Flag=0)
	begin
		update @TblMatiere set Flag=1 where Flag=0
		
		insert @TblMatiere(IdMatiere)
		select IdMatiere from  MATIERE where MATIERE.IdPere in (select IdMatiere from @TblMatiere where Flag=1)
		
		update @TblMatiere set Flag=2 where Flag=1
	end
	
	RETURN
END

--==========================================================


GO
/****** Object:  Table [dbo].[LienMatiere]    Script Date: 04/22/2009 16:34:35 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LienMatiere]') AND type in (N'U'))
DROP TABLE [dbo].[LienMatiere]
GO
/****** Object:  Table [dbo].[LienMatiere]    Script Date: 04/22/2009 16:34:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[LienMatiere](
	[IdLien] [int] IDENTITY(1,1) NOT NULL,
	[IdMatiereParent] [int] NOT NULL,
	[IdMatiereChild] [int] NOT NULL
) ON [PRIMARY]
--==================================================
/****   ****/
DECLARE @IdMatiere INT

DECLARE cur CURSOR FOR 
		SELECT DISTINCT IdMatiere
		FROM dbo.MATIERE

OPEN cur

FETCH NEXT FROM cur INTO @IdMatiere
WHILE @@FETCH_STATUS = 0
BEGIN
	
	INSERT dbo.LienMatiere (IdMatiereParent, IdMatiereChild)
	SELECT @IdMatiere, IdMatiere
	FROM dbo.GetSubMatiers(@IdMatiere)

	FETCH NEXT FROM cur INTO @IdMatiere

END
CLOSE cur
DEALLOCATE cur

/**************/


SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW [dbo].[view_R600a]
WITH SCHEMABINDING 
AS

SELECT  dbo.NOTICE_Z.IdNoticeZ, MATIERE.IdMatiere, dbo.NOTICE_Z.IdNotice, dbo.NOTICE_Z.IdZone, dbo.NOTICE_Z.sZone, 
		dbo.NOTICE_Z.NumOrdre, dbo.NOTICE_Z.NumOrdre2, cast(left(MATIERE.Sujet, 400) as nvarchar(400)) AS Valeur
FROM         dbo.NOTICE_Z INNER JOIN dbo.LienMatiere ON LienMatiere.IdMatiereParent=dbo.NOTICE_Z.ValeurN
			INNER JOIN dbo.MATIERE ON LienMatiere.IdMatiereChild=MATIERE.IdMatiere
WHERE     (dbo.NOTICE_Z.IdZone = 'R600') AND (dbo.NOTICE_Z.sZone = 'a')

GO

SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO

--======================================
GO
/****** Object:  View [dbo].[view_NOTICE_CATEG]    Script Date: 04/29/2009 21:11:50 ******/
IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[view_NOTICE_CATEG]'))
DROP VIEW [dbo].[view_NOTICE_CATEG]
GO
/****** Object:  View [dbo].[view_NOTICE_CATEG]    Script Date: 04/24/2009 16:24:15 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[view_NOTICE_CATEG]
AS
SELECT     IdNotice, Categ AS IdCategNotice
FROM         dbo.NOTICE

GO
--====================================

/****** :  UserDefinedFunction [dbo].[IsOPACRaservationAvailable]     : 05/25/2009 17:01:29 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[IsOPACRaservationAvailable]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[IsOPACRaservationAvailable]

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date, ,>
-- Description:	<Description, ,>
-- =============================================
CREATE FUNCTION [dbo].[IsOPACRaservationAvailable]
(
	-- Add the parameters for the function here
	@IdNotice int
)
RETURNS bit
AS
BEGIN
	
DECLARE @Result bit
SET @Result=0
IF((SELECT count(*) FROM EXEMPLAIRE
		 LEFT OUTER JOIN STATUTEXEMPLAIRE ON EXEMPLAIRE.IdStatut = STATUTEXEMPLAIRE.IdStatut
		 WHERE EXEMPLAIRE.idnotice = @IdNotice and STATUTEXEMPLAIRE.Pretable = 1 and STATUTEXEMPLAIRE.Reservable = 1
		 AND EXEMPLAIRE.IdExemplaire NOT IN (SELECT IdExemplaire FROM EXEMPLAIRE_RESA WHERE IdReservation IS NOT NULL) AND EXEMPLAIRE.IdExemplaire NOT IN (SELECT IdExemplaire FROM PRET))>0 
AND
	EXISTS (SELECT * FROM DetailParametre INNER JOIN
               PARAMETRE ON DetailParametre.IdParametre = PARAMETRE.IdParametre 
			WHERE     (PARAMETRE.CodeParametre = N'OPAC') AND (DetailParametre.CodeDetail = N'RESERVATION') AND (DetailParametre.Valeur = N'1'))
)

	-- Return the result of the function
	SET @Result=1
	
RETURN @Result

END
GO

SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO


/****** :  UserDefinedFunction [dbo].[GetParentMatiers]     : 05/25/2009 17:03:03 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[GetParentMatiers]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[GetParentMatiers]

--=====================================================
GO
/****** Object:  UserDefinedFunction [dbo].[GetSubMatiers]    Script Date: 04/29/2009 20:26:30 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE FUNCTION [dbo].[GetParentMatiers] (	@IdMatiere int )
RETURNS @TblMatiere TABLE 
(
	IdMatiere int
)
WITH SCHEMABINDING 
AS
BEGIN

	insert @TblMatiere(IdMatiere)
	values (@IdMatiere)
	
	declare @IdMatierPere int
	declare @flag bit
	set @flag = 1

	while @flag = 1
	begin
	
		select @IdMatierPere = IdPere from  dbo.MATIERE where IdMatiere = @IdMatiere
		if(@IdMatierPere is null or @IdMatierPere=0)
			set @flag = 0
		else
		begin
			insert @TblMatiere(IdMatiere)
			values (@IdMatierPere)

			set @IdMatiere = @IdMatierPere
		end

	end
	
	RETURN
END


GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


/****** :  Trigger [FillLienMatiere]     : 05/25/2009 17:04:41 ******/
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[dbo].[FillLienMatiere]'))
DROP TRIGGER [dbo].[FillLienMatiere]
GO

CREATE TRIGGER [dbo].[FillLienMatiere]
   ON  [dbo].[MATIERE]  
   AFTER INSERT, UPDATE
AS 
BEGIN

	SET NOCOUNT ON;
	
	DECLARE @IdMatiere INT
	SELECT @IdMatiere = inserted.IdMatiere FROM inserted

	DELETE LienMatiere WHERE IdMatiereChild = @IdMatiere
	
	INSERT LienMatiere (IdMatiereParent, IdMatiereChild)
	SELECT IdMatiere, @IdMatiere 
	FROM dbo.GetParentMatiers(@IdMatiere)

END
-- =============================================