<?php
/* $Id */
require_once 'RusmarkFieldCondition.php';

class FieldsSearchRequest extends Object{
	// 	MOD by isorokin
	// desc: full text search parameter and implem.
	//
	var $FullTextSearch = 0;
	var $ReqCrit = array();
	var $ReqCond = array();
	var $ReqSqlCond = array();
	var $ReqSqlOper = array();
	var $IdLangue = 4;

	function __construct($IdLangue = 4, $FullTextSearch) {
		$this->setFullTextSearch($FullTextSearch);
		$this->IdLangue = $IdLangue;
	}

	function setFullTextSearch($enabled) {
		$this->FullTextSearch = $enabled;
	}

	function generateSqlRequest(/*$aFields = array('IdNotice'), $sTable = 'NOTICE_Z'*/) {
		foreach ( $this->ReqCond as $i => $aCond ) {
			$this->ReqSqlCond[$i] = array();

			foreach ($aCond as $oRusmarkFieldCond) {
				// @var $oRusmarkFieldCond RusmarkFieldCondition
				if ($oRusmarkFieldCond->isOper()) {
					$this->ReqSqlOper[$i] = $oRusmarkFieldCond->getSqlOper();
				} else {
					$this->ReqSqlCond[$i][] = "\t(".$oRusmarkFieldCond->getSqlRequest().")\n";
				}
			}
			if (empty($this->ReqSqlOper[$i])) {
				$this->ReqSqlOper[$i] = ' INTERSECT ';
			}
			$this->ReqSqlCond[$i] = implode(' INTERSECT '."\n",$this->ReqSqlCond[$i]);
		}

		$this->ReqSqlOper[$i+1] = '';

		$sqlRequest = '';
		foreach ($this->ReqSqlCond as $k => $req) {
			$sqlRequest .= "(\n".$req.")\n" . $this->ReqSqlOper[$k+1] ."\n";
		}

		return $sqlRequest;
	}



	/**
	 * Отбирает элементы с ключем типа Cond#, # - номер условия
	 * Заполняет массив критериев и массив условий для каждого критерия
	 * 
	 * @param array $request
	 */
	function parseRequest($request, $reqConst = 'Cond') {
		$i=0;
		$critKey=$reqConst.($i+1);

		// Выделяем критерии из запроса
		//
		while (!empty($request[$critKey])) {
			// $Criteres=true;
			$this->ReqCrit[$i]=explode("|",$request[$critKey]);

			// сохраняем массив условий текущего критерия
			$this->ReqCond[$i] = $this->_parseCriteres($this->ReqCrit[$i]);

			$i++;
			$critKey = $reqConst.($i+1);
		}

		//return $this->ReqCrit;
		return;
	}

	/**
	 * Обрабатывает критерий $aCrit и генерирует условия для критерия
	 *
	 * @param array $aCrit
	 * @return array массив условий для критерия
	 */
	function _parseCriteres($aCrit) {
		$result = array();

		foreach ($aCrit as $sExpr) {
			$result[] = new RusmarkFieldConditionOpac($sExpr);
		}

		return $result;
	}
}

class OpacRequest extends FieldsSearchRequest {

	var $_sqlHeadTpl = '';
	var $_sqlEndTpl  = '';

	function __construct($IdLangue=4){
		
		$index_join = '';
		switch (Configure::read('opac.search.index_udc')){
			case 'COTE':
				$index = 'CAST(dbo.fn_RIID_COTE_NOTICE(NOTICE.IdNotice, 1) AS nvarchar(50)) AS Cote,';
				break;
			case 'BBK':
				$index = 'CAST(udc.Valeur AS nvarchar(50)) AS Cote,';
				$index_join = "LEFT JOIN view_NOTICE_675a_686a udc  ON udc.IdNotice = Notice.IdNotice and udc.IdZone = '686' AND udc.sZone = 'a'";
				break;
			case 'UDCBBK':
				$index = 'CAST(udc.Valeur AS nvarchar(50)) AS Cote,';
				$index_join = "LEFT JOIN view_NOTICE_675a_686a udc  ON udc.IdNotice = Notice.IdNotice and udc.NumOrdre = 0";
				break;
			case 'UDC':
			default:
				$index = 'CAST(udc.Valeur AS nvarchar(50)) AS Cote,';
				$index_join = "LEFT JOIN view_NOTICE_675a_686a udc  ON udc.IdNotice = Notice.IdNotice and udc.IdZone = '675' AND udc.sZone = 'a'";
				break;
	
		}
		
		$limit = coalesce(Configure::read(LIBER_OPAC_SEARCH.'.limit'), 'TOP 2000');
		
		$this->_sqlHeadTpl= '
			SELECT '.$limit.' NOTICE.IdNotice, NOTICE.Categ,   
					#AUTHOR#,
					NOTICE.Titre + coalesce((select top 1 \' \'+valeur from NOTICE_Z where NOTICE.IdNotice = IdNotice and idzone = \'207\' and szone = \'a\') ,\'\') 
						collate French_CI_AS AS Titre,  
					view_210c.Valeur AS Editeur, 
					CAST(dbo.fn_RIID_NOTICE_VALEUR(NOTICE.IdNotice, \'210\', \'d\', 0) AS nvarchar(max)) AS Date,  
					v01x.Valeur AS ISBN,
					'.$index.' 
					v856u.Valeur AS URL, cast(dbo.IsOPACRaservationAvailable(NOTICE.IdNotice) as int)*NOTICE.IdNotice AS Resevre,
					ROW_NUMBER() OVER (ORDER BY Titre) AS RowNumber,
					---Exemplares---  
					_CATEG_NOTICE.Image, CAST(_CATEG_NOTICE.Libelle AS nvarchar(255)) AS Libelle 
					FROM NOTICE 
					INNER JOIN _CATEG_NOTICE ON NOTICE.Categ = _CATEG_NOTICE.IdCategNotice AND (_CATEG_NOTICE.IdLangueSoft ='.intval($IdLangue).')
					LEFT JOIN dbo.view_NOTICE_200a_100char v200a  ON v200a.IdNotice = NOTICE.IdNotice 
					LEFT JOIN view_200fg  ON view_200fg.IdNotice = NOTICE.IdNotice AND view_200fg.sZone = \'f\'
					'.$index_join.'
					LEFT JOIN view_200fg v200g  ON v200g.IdNotice = NOTICE.IdNotice AND v200g.sZone = \'g\' AND v200g.NumOrdre = 0
					LEFT JOIN view_210c  ON view_210c.IdNotice = NOTICE.IdNotice AND view_210c.NumOrdre = 0
					LEFT JOIN view_NOTICE_01x v01x  ON v01x.IdNotice = NOTICE.IdNotice AND v01x.sZone = N\'a\' AND v01x.IdZone = N\'010\' AND (v01x.NumOrdre IS NULL OR v01x.NumOrdre = 0) 
					LEFT JOIN view_NOTICE_856u v856u  ON v856u.IdNotice = NOTICE.IdNotice AND v856u.NumOrdre = 0
		';
		
		$author_sql = "CASE
     				WHEN view_200fg.Valeur IS NOT NULL THEN view_200fg.Valeur
	 				ELSE v200g.Valeur END AS Auteur";
		
		if ( is_array($fields = configure::read('opac.auteur.name')) ) {
			foreach ($fields as $field) {
				$coalecses[] = "$field COLLATE Cyrillic_General_CI_AS";
			}
			$coalecse = implode(', ', $coalecses);
		  	$author_sql = "(select 
				   Nom + ' '+
				   COALESCE($coalecse, '') 
				   from auteur where  idAuteur IN 
				   (select top 1 idAuteur from dbo.view_200fg where dbo.view_200fg.idNotice = NOTICE.IdNotice)) AS Auteur
	 		";
		}
		
		
		$this->_sqlHeadTpl = str_replace('#AUTHOR#', $author_sql, $this->_sqlHeadTpl);

		$defaultSortOrder = coalesce(Configure::read(LIBER_OPAC_SEARCH.'.defaultSortOrder'), 'Titre ASC');
		$this->_sqlEndTpl = ' ORDER BY '.$defaultSortOrder;
	}

	function genNoticeSQL($idNotice) {
		$sqlCond = ' WHERE NOTICE.IdNotice = '.intval($idNotice). ' and NOTICE.NotAvailableOpac = 0';
		$sql = $this->_sqlHeadTpl.$sqlCond;
		return $sql;
	}

	function genBooksSearchSQL($emp_parametrs, $getCount = false) {
		//$this->_getExemplareCondinion($emp_parametrs);
		if ($getCount) {
			$this->_sqlHeadTpl = 'SELECT count(IdNotice) FROM NOTICE ';
			$this->_sqlEndTpl = '';
		}

		$sqlCond = $this->ReqCond;

		if(Configure::read()) {
			AppController::log('***Search condition:***', 'searches');
			AppController::log($sqlCond, 'searches');
		}

		if(!empty($sqlCond)) {
			$sqlCond = ' WHERE NOTICE.IdNotice IN ('.$sqlCond.') and NOTICE.NotAvailableOpac = 0';
		}
		$sqlCond .= ' #addition_cond# '; 

		$sql = $this->_sqlHeadTpl.$sqlCond.$this->_sqlEndTpl;
		return $sql;
	}

	/**
	 * 
	 * add description
	 * 
	 * @param array $request
	 */
	function parseSimpleRequest($aConditions) {

		foreach ($aConditions as $aCond) {
			if (is_array($aCond)) {
				if ($aCond['value']!='') {
					$new = &$this->ReqCond[];
					$new[] = new Operation($aCond);
					$new[] = new SimpeCondition($aCond);
				}
			}
		}

		//return $this->ReqCrit;
		return;
	}

	/**
	 * Формирует строку запроса условия поиска по экземплярам
	 *
	 * @param array $filial_param - условия поиска по филиалам
	 * @return string - часть sql-запроса
	 */
//	function _getExemplareCondinion($filial_param){
//		unset($filial_param['all']);
//		
//		$aFilials = array_keys($filial_param, 1);
//		if (empty($aFilials)) {
//			return '';
//		}		
//		
//		$empCond = 'EXEMPLAIRE.idnotice = NOTICE.IdNotice ' ;
//		$filials = ' AND ( EXEMPLAIRE.idAnnexe IN (%s))';
//		$filials = sprintf($filials, implode(',', $aFilials));
//		
//		$empCond = '(SELECT COUNT(*) FROM EXEMPLAIRE WHERE '.$empCond.$filials.' ) AS NbrEx,';
//
//		// делаем метод статическим
//		//$this->_sqlHeadTpl = str_replace('---Exemplares---',$empCond,$this->_sqlHeadTpl);
//		return $empCond;
//	}

}

?>