<?php

// @ver 0.5
require_once('FieldsOptions.php');

define ( 'ERROR_OUTFIELD_MUST_BE_ARRAY', 'Output field must be an array' );

function _sql($value) {
	return addslashes ( $value );
}

/**
 * Singleton helper для всех классов. Пока не используется. Пока.
 *
 */
/*
class Singleton {
function getInstance($class) // implements the 'singleton' design pattern.
{
static $instances = array (); // array of instance names
if (! array_key_exists ( $class, $instances )) {
// instance does not exist, so create it
$instances [$class] = & new $class ( );
} // if
$instance = & $instances [$class];
return $instance;
} // getInstance
} // singleton
*/

class FieldCondition {
	var $NomCritere = '';
	var $ValCritere = '';
	var $OperEgalite = '';
	var $TypeCritere = ''; // z OR clez
	var $idZone = '';
	var $sZone = '';
	var $isFullText = false;
	var $valeurField = 'Valeur';
	var $sqlRequest = '';
	var $_outFields = array ('IdNotice' );
	var $_defaultView = 'view_NOTICE_Z';
	
	function FieldCondition() {
		$args = func_get_args ();
		call_user_func_array ( array (&$this, "__construct" ), $args );
	}

	function _getSqlConditionTpl() {
		// Добавлено для одновременного поиска по заглавию,
		// подзаголовочным данным и комментариям
		//
		if ($this->idZone == '200' and $this->sZone == 'a') {
			return ' #operEgaliteTpl#';
		}
		
		if ($this->idZone == '200' and $this->sZone == 'f') {
			return 'IdZone = \'200\' AND (sZone = \'f\' OR sZone = \'g\') AND #operEgaliteTpl#';;
		}

		if (! empty ( $this->TypeCritere )) {
			return 'IdZone = \'#idZone#\' AND sZone = \'#sZone#\' AND #operEgaliteTpl#';
		}
		return '';
	}

	function _getOperEgaliteTpl() {
		if (trim($this->OperEgalite) == 'CONTAINS') {
			return 'CONTAINS(#ValeurField#, #ValCritere#)';
		} elseif (trim($this->OperEgalite) == 'IN') {
			return '#ValeurField# #OperEgalite# (#ValCritere#)';
		}
		return '#ValeurField# #OperEgalite##ValCritere#';
	}

	function _getSqlRequestTpl() {
		if (! empty ( $this->TypeCritere )) {
			return 'SELECT #sOutFields# FROM #UseView# #WithNoExpand# WHERE #sSqlCond#';
		}
		return '';
	}

	function isOper() {
		return ($this->NomCritere == 'oper');
	}

	function getSqlOper() {
		if ($this->isOper ()) {
			// example: ValCritere == '2'
			$iOper = intval ( $this->ValCritere );
			if ($iOper == 0)
			//return ' AND ';
			return ' INTERSECT ';
			if ($iOper == 1)
			//return ' OR ';
			return ' UNION ';
			if ($iOper == 3)
			//return ' NOT ';
			return ' EXLUDE ';

			// default operation
			return 'INTERSECT';
		}
		return '';
	}

	function getSqlCondition() {
		
		if($this->NomCritere == '675_a'){
			if('COTE' == Configure::read('opac.search.index_udc')){
				return 'cote '.$this->OperEgalite.$this->ValCritere;
			}
		}
		
		$sql = $this->_getSqlConditionTpl ();
		if (empty ( $sql ))
		return $sql;

		$sql = str_replace ( '#operEgaliteTpl#', $this->_getOperEgaliteTpl (), $sql );
		$values = array (_sql ( $this->idZone ), _sql ( $this->sZone ), $this->valeurField, $this->OperEgalite, $this->ValCritere );
		$tokens = array ('#idZone#', '#sZone#', '#ValeurField#', '#OperEgalite#', '#ValCritere#' );

		$sql = str_replace ( $tokens, $values, $sql );

		/*
		if (! empty ( $this->TypeCritere )) {
		$sql = vprintf ( $sql, array ($this->idZone, $this->sZone, $this->OperEgalite, $this->ValCritere ) );
		}
		*/
		
		return $sql;
	}

	/**
	 * Формирует участок SQL запроса для случая
	 * поиска по отображениям(View), у которых отсутствует sZone
	 * @example "codebare LIKE N'12323'"
	 * 
	 * @return string $cond - условия поиска
	 */
	function getExtSqlCondition(){

		$cond = $this->NomCritere.' '.$this->OperEgalite.$this->ValCritere;

		if($this->NomCritere == 'everywhere'){
			$cond = 'valeur '.$this->OperEgalite.$this->ValCritere;
			return $cond;
		}
		
		if($this->NomCritere == 'categ'){
			$cond = 'Categ IN ('.$this->ValCritere.')';
			return $cond;
		}
		
		if($this->NomCritere == '675_a'){
			if('COTE' == Configure::read('opac.search.index_udc')){
				return 'cote '.$this->OperEgalite.$this->ValCritere;
			}
		}
		
		if ($this->idZone == 'sujetrech') {
			$cond =
			'(IdZone = \'R600\') AND (sZone = \'a\') AND ValeurN 
			IN (
				SELECT col FROM
   					(select IdRetenue, IdMatiere from MATIERE  WHERE '.$cond.') p
				UNPIVOT (col FOR xxx IN(IdRetenue, IdMatiere))AS unpvt
				UNION 
				SELECT IdMatiereChild AS IdMatiere FROM LienMatiere WHERE LienMatiere.IdMatiereParent 
				IN (SELECT IdMatiere FROM MATIERE WHERE '.$cond.')
			)';
		}
		
		if($this->idZone == 'r600id'){
			$cond =
				'
				(IdZone = \'R600\') AND (sZone = \'a\') AND ValeurN 
				IN ('.str_replace("'",'',$this->ValCritere).')';
		}

		return $cond;
	}

	/**
	 * Enter description here...
	 *
	 * @param array $aOutField
	 * @return bool
	 */
	function setOutField($aOutFields) {
		if (is_array ( $aOutFields )) {
			$this->_outFields = $aOutFields;
		} else {
			return new PEAR_Error ( ERROR_OUTFIELD_MUST_BE_ARRAY );
		}
		return true;
	}

	function getSqlRequest() {
		$FieldOptions = FieldOptions::getInstance ();
		
		$useField = $FieldOptions->getField ( $this->idZone, $this->sZone );
		if($useField !== false){
			return $this->_getFieldRequest($useField);
		}

		$aOutFields = $this->_outFields;

		if (is_array ( $aOutFields )) {
			$this->_outFields = $aOutFields;
		} else {
			return new PEAR_Error ( ERROR_OUTFIELD_MUST_BE_ARRAY );
		}

		$sql = $this->_getSqlRequestTpl ();

		if (empty ( $sql ))
		return $sql;
		
		// проверка существование IdZone и sZone
		if( !empty($this->idZone) && !empty($this->sZone)){
			// стандартная функция формирования условий
			$sqlCond = $this->getSqlCondition ();
		}elseif(!empty($this->idZone)){
			// дополнительная функция формирования условий
			$sqlCond = $this->getExtSqlCondition();
		}

		$sOutFields = implode ( ',', $this->_outFields );

		$useView = $FieldOptions->getView ( $this->idZone, $this->sZone );
		
		if(!in_array($this->idZone, array('sujetrech', 'r600','idcategnotice','categ','r600id'))) {
			$withNoExpand = '';
		} else {
			$withNoExpand = '';
		}

		if (empty ( $useView )) {
			$useView = $this->_defaultView;
			$withNoExpand = ' ';
		}

		if ($useView == 'view_NOTICE_225ai') {  // Исправляем поиск серий
			$withNoExpand = ' ';
		}
		
		// поиск по ссылкам для авторов
		if($this->idZone == '200' &&  in_array($this->sZone,array('f','g')) ){
			$sqlCond = 'IdAuteur in(
				SELECT col FROM
   					(select Voir, IdAuteur from AUTEUR  where idauteur in 
						(SELECT IdAuteur FROM '.$useView.'  WHERE '.$sqlCond.')) p
				UNPIVOT (col FOR xxx IN(Voir, IdAuteur))AS unpvt)';
		}
		
		$tokens = array ('#sOutFields#', '#UseView#', '#WithNoExpand#', '#sSqlCond#' );
		$values = array ($sOutFields, $useView, $withNoExpand, $sqlCond );

		$sql = str_replace ( $tokens, $values, $sql );
		$this->sqlRequest = $sql;
		return $this->sqlRequest;
	}
	
	function _getFieldRequest($useField){
		$sql_template = 'SELECT %s FROM %s WHERE %s ';
		
		$cond = $this->_getFieldCond($useField['column']);	
		$out = sprintf($sql_template, implode(',', $this->_outFields), $useField['table'], $cond);				
		return  $out;
	}
	
	/**
	 * Возвращает условие для поиска по полю.
	 * @return string
	 */
	function _getFieldCond($column,$searchVal=null){
		if (!$column) return '';
		$val = ($searchVal) ? $searchVal : $this->ValCritere;
		$oper =  $this->OperEgalite;
		
		switch ($oper){
			case "LIKE N": 	$out = "%s  $oper%s";
				break;
			case "CONTAINS":$out = "$oper (%s, %s)";
				break;
			case "IN": 		$out = "%s $oper (%s)";
				break;
			default: 		$out = "%s = %s";
				break;
		}
		return sprintf($out,$column,$val);
	}

	function assignOperEngalite($code = '') {
		if (empty ( $code ))
		$code = 'DEFAULT';

		$oOptions = FieldOptions::getInstance ();
		$this->OperEgalite = $oOptions->aOperations [$code];

		if (($this->TypeCritere == 'z') && ($this->OperEgalite == '=')) {
			if ($this->isFullText) {
				$this->OperEgalite = 'CONTAINS';
			} else {
				if ($this->idZone=='210' && $this->sZone=='d') {
					return $this->OperEgalite = '';
				}
				$this->OperEgalite = 'LIKE N';
			}
		}

		if ($this->TypeCritere == 'clez') {
			$this->OperEgalite = 'IN';
		}

	}

	function setNomCritere($nom) {
		$nom = trim ( strtolower ( $nom ) );
		if ($nom{0} == 'z') {
			$this->TypeCritere = 'z';
			$this->NomCritere = substr ( $nom, 1 );
			$this->valeurField = 'Valeur';
		} elseif (strpos ( $nom, 'clez' ) === 0) {
			$this->TypeCritere = 'clez';
			$this->NomCritere = substr ( $nom, 4 );
			$this->valeurField = 'ValeurN';
		} else {
			$this->NomCritere = $nom;
		}
	}

	/**
	 * Определяет IdZone и sZone анализируя свой TypeCritere и NomCritere
	 * 
	 */
	function _detZones() {
		if (! empty ( $this->TypeCritere )) {
			$aZones = explode ( '_', $this->NomCritere );
			$this->idZone = $aZones [0];
			$this->sZone = $aZones [1];
		}
	}

	function _detFullTextSearch() {
		$idZone = &$this->idZone;
		$sZone = &$this->sZone;

		// @var $oOptions FieldOptions
		$oOptions = FieldOptions::getInstance ();

		if (key_exists ( $idZone, $oOptions->aFullTextFields )) {
			if (in_array ( $sZone, $oOptions->aFullTextFields [$idZone] )) {
				$this->isFullText = true;
			}
		}
	}

	function sqlFormat($val) {

		if (! $this->isFullText) {
			if ($this->TypeCritere == 'z') {
				$val = str_replace ( "'", "''", $val );
			} else {
				$val = ereg_replace ( '[^0-9,]+', '', $val );
				$val = eregi_replace ( ',$', '', $val );
				return $val;
			}
			$val = str_replace ( '*', '%', $val );
			
			// Для поиска по дате не будем добавлять кавычки
			if ($this->idZone == '210' && $this->sZone == 'd') {
				return $val;
			}
			
			return "'" . $val . "'";
		} else {
			// Последовательность символов, на которую временно заменим звездочки 
			$star = 'ъXъXъ'; 
			// временно заменим звездочки 
			$val = preg_replace('/\*/u', $star, $val);
			$words = array();
			//$n = '/(?<= |^|\b[^"|\'])("|\')[^\1]*?\1|(\pL|\'|"|\x0a)+/u'; // break words
			$n = '/(?<= |^|\b[^"|\'])("|\')[^\1]*?\1|(\D*\d+\D*)|(\pL|\'|"|\x0a)+/u';
			preg_match_all($n, $val, $matches);
			mb_internal_encoding('UTF-8');
			
			foreach ($matches[0] as $v) {
				// заменим $star обратно на звездочки
				$v = preg_replace("/$star/u", '*', $v);
				$v = '"'.preg_replace(array("/[\"]/u","/[']/u"), array('',"''"), $v).'"'; 
				$words[] = $v;
			};
			$val = implode(' & ', $words);

			$val = "'" . $val . "'";
		}

		return $val;
	}


	function __construct() {

	}
}

class RusmarkFieldCondition extends FieldCondition {

	var $_nom = '';
	var $_val = '';

	function analyseExp(&$zExpression) {
		$aNomAndVal = explode ( '=', $zExpression );
		$this->_nom = $aNomAndVal [0];
		$this->_val = $aNomAndVal [1];
		return;
	}


	function RusmarkFieldCondition($zExpression) {
		parent::__construct ();

		$this->analyseExp($zExpression);

		$nom = $this->_nom;
		$val = $this->_val;

		//---- Test si la valeur est une chaîne "critère"
		// Ex : DATEACQUISITION[SE[01-01-2005
		//	Dans ce cas :
		//			$NomCritere est remplacé par $ReqCritChm[0]
		//			$OperEgalite par $ReqCritChm[1]
		//			$ValCritere par $ReqCritChm[2]
		$aChm = explode ( '[', $val );

		if (count ( $aChm ) > 1) {
			$this->NomCritere = $aChm [0];
			$this->ValCritere = $aChm [2];
			$code = $aChm [1];
			$this->assignOperEngalite ( $code );
			return;
		}

		// Определяем $NomCritere
		//
		$this->setNomCritere ( $nom );
		$this->_detZones ();
		$this->_detFullTextSearch ();
		$this->ValCritere = $this->sqlFormat ( $val );

		$this->assignOperEngalite ();
		// Определим IdZone и sZone


	}
}

class RusmarkFieldConditionOpac extends RusmarkFieldCondition {
	function analyseExp(&$zExpression) {
		$aNomAndVal = explode ( ':', $zExpression );

		$this->_nom = 'z'.trim(strtolower($aNomAndVal [0]));
		if ($this->_nom == 'ztype') $this->_nom = 'oper';

		$this->_val = end($aNomAndVal);

		return;
	}
}

class Operation extends FieldCondition {
	function Operation($aCondition) {
		parent::__construct ();
		$this->setNomCritere('oper');
		if (!key_exists('oper', $aCondition)) {
			$aCondition['oper'] = 'AND';
		}

		$this->ValCritere = $aCondition['oper'];
	}

	function getSqlOper() {
		if ($this->isOper ()) {
			// example: ValCritere == '2'
			$Oper = trim($this->ValCritere);
			if ($Oper == 'AND')
			//return ' AND ';
			return ' INTERSECT ';

			if ($Oper == 'OR')
			//return ' OR ';
			return ' UNION ';

			if ($Oper == 'NOT')
			//return ' NOT ';
			return ' EXCEPT ';

			// default operation
			return ' INTERSECT ';
		}
		LogError('Empty operation detected in search request');
		return '';
	}
}

class SimpeCondition extends FieldCondition {
	function SimpeCondition($aCondition) {
		parent::__construct ();
		if (strpos($aCondition['field'], 'clez') === 0) {
			$nom = $aCondition['field'];	
		} else {
			$nom = 'z'.$aCondition['field'];
		}
		$val = $aCondition['value'];


		// Определяем
		//
		$this->setNomCritere ( $nom );
		$this->_detZones ();
		$this->_detFullTextSearch ();
		$this->ValCritere = $this->sqlFormat ( $val );
		$this->assignOperEngalite();
	}
}

class RusmarkFieldConditionSimple {
	function RusmarkFieldConditionSimple($aCondition) {
		$res = array();
		$res[] = new Operation($aCondition);
		$res[] = new SimpeCondition($aCondition);
		return $res;
	}
}
?>